// InvisibleWnd.cpp : t@C
//

#include "stdafx.h"
#include "InvisibleWnd.h"
#include "NigeroDlg.h"
#include "resource.h"

#pragma warning(disable:4996)

#define WM_NOTIFY_TRAY_ICON (WM_APP + 0)

// CInvisibleWnd

IMPLEMENT_DYNAMIC(CInvisibleWnd, CWnd)

BEGIN_MESSAGE_MAP(CInvisibleWnd, CWnd)
	ON_WM_CREATE()
	ON_WM_PAINT()
	ON_WM_TIMER()
END_MESSAGE_MAP()

CInvisibleWnd::CInvisibleWnd()
{
}

CInvisibleWnd::~CInvisibleWnd()
{
}

void CInvisibleWnd::Layout()
{
	int x = GetSystemMetrics(SM_CXSCREEN);
	int y = GetSystemMetrics(SM_CYSCREEN);
	::SetWindowPos(GetSafeHwnd(), HWND_TOPMOST, x - 2, y - 2, 1, 1, SWP_NOACTIVATE);
}

void CInvisibleWnd::OpenConsoleDialog()
{
	CNigeroDlg dlg;
	if (dlg.DoModal() == ID_EXIT) {
		PostMessage(WM_CLOSE);
	}
}

BOOL CInvisibleWnd::Create(CWnd *parent)
{
	return CFrameWnd::Create(AfxRegisterWndClass(0), L"Nigero", WS_POPUP | WS_VISIBLE, CRect(0, 0, 0, 0), parent, 0, WS_EX_TOOLWINDOW);
}

LRESULT CInvisibleWnd::WindowProc(UINT message, WPARAM wParam, LPARAM lParam)
{
	switch (message) {
	case WM_NULL:
		Layout();
		return 0;
	case WM_NCCALCSIZE:
		return 0;
	case WM_CLOSE:
		return 0;
	case WM_ERASEBKGND:
		return 0;
	case WM_SETCURSOR:
		SetCursor(0);
		return 0;
	case WM_DISPLAYCHANGE:
		Layout();
		return 0;
	case WM_NOTIFY_TRAY_ICON:
		switch (lParam) {
		case WM_LBUTTONDBLCLK:
			OpenConsoleDialog();
		}
		return 0;
	}

	return CFrameWnd::WindowProc(message, wParam, lParam);
}

int CInvisibleWnd::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	if (CFrameWnd::OnCreate(lpCreateStruct) == -1)
		return -1;

	ModifyStyle(WS_CAPTION | WS_THICKFRAME, 0);
	ModifyStyleEx(WS_EX_CLIENTEDGE, WS_EX_NOACTIVATE | WS_EX_LAYERED);

	SetLayeredWindowAttributes(0, 1, LWA_ALPHA);

	Layout();

	m_notify_icon.cbSize = sizeof(NOTIFYICONDATA);
	m_notify_icon.uID = 1;
	m_notify_icon.hWnd = m_hWnd;
	m_notify_icon.uFlags = NIF_MESSAGE | NIF_ICON | NIF_TIP;
	m_notify_icon.hIcon = LoadIcon(AfxGetInstanceHandle(), MAKEINTRESOURCE(IDI_TASKTRAY));
	m_notify_icon.uCallbackMessage = WM_NOTIFY_TRAY_ICON;
	wcscpy(m_notify_icon.szTip, L"Nigero");
	Shell_NotifyIcon(NIM_ADD, &m_notify_icon);

	SetTimer(0, 1000, 0);

	return 0;
}

void CInvisibleWnd::OnPaint()
{
	CPaintDC dc(this);
	RECT rc;
	GetClientRect(&rc);
	dc.PatBlt(0, 0, rc.right, rc.bottom, BLACKNESS);
}

void CInvisibleWnd::OnTimer(UINT_PTR nIDEvent)
{
	HWND w = ::GetWindow(::GetDesktopWindow(), GW_CHILD);
	while (w) {
		if (w == GetSafeHwnd()) {
			break;
		}
		if (::IsWindowVisible(w)) {
			if (w != GetSafeHwnd()) {
				Layout();
				break;
			}
		}
		w = ::GetWindow(w, GW_HWNDNEXT);
	}
}
