// NigeroDlg.cpp : t@C
//

#include "stdafx.h"

#include "Nigero.h"
#include "NigeroDlg.h"
#include "NigeroAPI.h"
#include "AddAppDlg.h"

#include <algorithm>

#pragma warning(disable:4996)

std::wstring GetInitFilePath();
std::wstring GetExcludeApplicationFilePath();

// CNigeroDlg _CAO

IMPLEMENT_DYNAMIC(CNigeroDlg, CDialog)

BEGIN_MESSAGE_MAP(CNigeroDlg, CDialog)
	ON_BN_CLICKED(IDC_BUTTON_ABOUT, &CNigeroDlg::OnBnClickedButtonAbout)
	ON_BN_CLICKED(ID_EXIT, &CNigeroDlg::OnBnClickedExit)
	ON_BN_CLICKED(IDC_BUTTON_ADD_APP, &CNigeroDlg::OnBnClickedButtonAddApp)
	ON_BN_CLICKED(IDC_BUTTON_REMOVE_APP, &CNigeroDlg::OnBnClickedButtonRemoveApp)
	ON_BN_CLICKED(IDC_BUTTON_STARTUP, &CNigeroDlg::OnBnClickedButtonStartup)
END_MESSAGE_MAP()

CNigeroDlg::CNigeroDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CNigeroDlg::IDD, pParent)
{
}

CNigeroDlg::~CNigeroDlg()
{
}

void CNigeroDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_LIST1, _list_box);
}

void CNigeroDlg::LoadExcludeApplicationList()
{
	_exclude_applications.clear();

	std::wstring path = GetExcludeApplicationFilePath();
	FILE *fp = _wfopen(path.c_str(), L"r");
	if (fp) {
		while (!feof(fp)) {
			char tmp[1000];
			if (fgets(tmp, sizeof(tmp), fp)) {
				wchar_t ucs[1000];
				int len = MultiByteToWideChar(CP_ACP, 0, tmp, strlen(tmp), ucs, 1000);
				wchar_t const *left = ucs;
				wchar_t const *right = ucs + len;
				while (left < right && iswspace(right[-1])) {
					right--;
				}
				while (left < right && iswspace(left[0])) {
					left++;
				}
				if (left < right) {
					_exclude_applications.push_back(std::wstring(left, right));
				}
			}
		}
		fclose(fp);
	}
}

void CNigeroDlg::UpdateListBox()
{
	_list_box.ResetContent();
	for (size_t i = 0; i < _exclude_applications.size(); i++) {
		_list_box.AddString(_exclude_applications[i].c_str());
	}
}

void CNigeroDlg::SaveApplicationExclusionList()
{
	std::wstring path = GetExcludeApplicationFilePath();
	FILE *fp = _wfopen(path.c_str(), L"w");
	if (fp) {
		for (std::vector<std::wstring>::const_iterator it = _exclude_applications.begin(); it != _exclude_applications.end(); it++) {
			char tmp[1000];
			int len = WideCharToMultiByte(CP_ACP, 0, it->c_str(), it->size(), tmp, 998, 0, 0);
			tmp[len++] = '\n';
			tmp[len++] = 0;
			fputs(tmp, fp);
		}
		fclose(fp);
	}
}

bool CNigeroDlg::GetCheck(int idc)
{
	HWND w = ::GetDlgItem(GetSafeHwnd(), idc);
	if (w && (::SendMessage(w, BM_GETCHECK, 0, 0) & BST_CHECKED)) {
		return true;
	}
	return false;
}

static wchar_t const *boolstr(bool f)
{
	return f ? L"1" : L"0";
}

void CNigeroDlg::ApplySettings()
{
	std::wstring inipath = GetInitFilePath();

	bool f;

	f = GetCheck(IDC_CHECK_LEFT_SHIFT);
	nigero_set_suppressor(VK_LSHIFT, f);
	WritePrivateProfileString(L"Nigero", L"vk_lshift",   boolstr(f), inipath.c_str());

	f = GetCheck(IDC_CHECK_LEFT_CTRL);
	nigero_set_suppressor(VK_LCONTROL, f);
	WritePrivateProfileString(L"Nigero", L"vk_lcontrol", boolstr(f), inipath.c_str());

	f = GetCheck(IDC_CHECK_LEFT_ALT);
	nigero_set_suppressor(VK_LMENU, f);
	WritePrivateProfileString(L"Nigero", L"vk_lmenu",    boolstr(f), inipath.c_str());

	f = GetCheck(IDC_CHECK_RIGHT_SHIFT);
	nigero_set_suppressor(VK_RSHIFT, f);
	WritePrivateProfileString(L"Nigero", L"vk_rshift",   boolstr(f), inipath.c_str());

	f = GetCheck(IDC_CHECK_RIGHT_CTRL);
	nigero_set_suppressor(VK_RCONTROL, f);
	WritePrivateProfileString(L"Nigero", L"vk_rcontrol", boolstr(f), inipath.c_str());

	f = GetCheck(IDC_CHECK_RIGHT_ALT);
	nigero_set_suppressor(VK_RMENU, f);
	WritePrivateProfileString(L"Nigero", L"vk_rmenu",    boolstr(f), inipath.c_str());

	f = GetCheck(IDC_CHECK_SPACE);
	nigero_set_suppressor(VK_SPACE, f);
	WritePrivateProfileString(L"Nigero", L"vk_space",    boolstr(f), inipath.c_str());
}

BOOL CNigeroDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	HICON hIconSmall = (HICON)::LoadImage(AfxGetInstanceHandle(), MAKEINTRESOURCE(IDI_TASKTRAY), IMAGE_ICON, ::GetSystemMetrics(SM_CXSMICON), ::GetSystemMetrics(SM_CYSMICON), LR_DEFAULTCOLOR);
	SetIcon(hIconSmall, FALSE);

	if (nigero_is_suppressor(VK_LSHIFT))   SendDlgItemMessage(IDC_CHECK_LEFT_SHIFT,  BM_SETCHECK, BST_CHECKED);
	if (nigero_is_suppressor(VK_LCONTROL)) SendDlgItemMessage(IDC_CHECK_LEFT_CTRL,   BM_SETCHECK, BST_CHECKED);
	if (nigero_is_suppressor(VK_LMENU))    SendDlgItemMessage(IDC_CHECK_LEFT_ALT,    BM_SETCHECK, BST_CHECKED);
	if (nigero_is_suppressor(VK_RSHIFT))   SendDlgItemMessage(IDC_CHECK_RIGHT_SHIFT, BM_SETCHECK, BST_CHECKED);
	if (nigero_is_suppressor(VK_RCONTROL)) SendDlgItemMessage(IDC_CHECK_RIGHT_CTRL,  BM_SETCHECK, BST_CHECKED);
	if (nigero_is_suppressor(VK_RMENU))    SendDlgItemMessage(IDC_CHECK_RIGHT_ALT,   BM_SETCHECK, BST_CHECKED);
	if (nigero_is_suppressor(VK_SPACE))    SendDlgItemMessage(IDC_CHECK_SPACE,       BM_SETCHECK, BST_CHECKED);

	SetForegroundWindow();

	LoadExcludeApplicationList();

	UpdateListBox();

	return TRUE;
}

void CNigeroDlg::OnBnClickedExit()
{
	ApplySettings();
	AfxGetMainWnd()->PostMessage(WM_CLOSE, 0, 0);
}

void CNigeroDlg::OnBnClickedButtonAbout()
{
	theApp.OnAppAbout();
}

void CNigeroDlg::OnBnClickedButtonAddApp()
{
	CAddAppDlg dlg;
	if (dlg.DoModal() == IDOK) {
		std::vector<std::wstring> const *vec = dlg.GetArray();
		for (std::vector<std::wstring>::const_iterator it = vec->begin(); it != vec->end(); it++) {
			_exclude_applications.push_back(*it);
		}
		if (!_exclude_applications.empty()) {
			std::sort(_exclude_applications.begin(), _exclude_applications.end());
			std::vector<std::wstring>::iterator it = std::unique(_exclude_applications.begin(), _exclude_applications.end());
			_exclude_applications.resize(it - _exclude_applications.begin());
		}
		SaveApplicationExclusionList();
		UpdateListBox();
	}
}

void CNigeroDlg::OnBnClickedButtonRemoveApp()
{
	int sel = _list_box.GetCurSel();
	if (sel >= 0 && sel < (int)_exclude_applications.size()) {
		_exclude_applications.erase(_exclude_applications.begin() + sel);
		SaveApplicationExclusionList();
		UpdateListBox();
	}
}


void CNigeroDlg::OnBnClickedButtonStartup()
{
	wchar_t tmp[1000];
	if (SHGetSpecialFolderPath(0, tmp, CSIDL_STARTUP, FALSE)) {
		ShellExecute(0, L"open", tmp, 0, 0, SW_SHOWNORMAL);
	}
}

void CNigeroDlg::OnCancel()
{
	ApplySettings();
	CDialog::OnCancel();
}
